/* Problem URL: https://codeforces.com/contest/954/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    long double t;
    cin >> n >> t;

    V<pair<long double, long double>> a(n);
    repv(i, a) {
        cin >> i.second;
    }
    repv(i, a) {
        cin >> i.first;
    }

    sort(all(a), [&](pair<long double, long double> &a, pair<long double, long double> &b) {
            if (a.first == b.first) {
                return a.second > b.second;
            }
            return a.first < b.first;
         });

    long double start = 0;
    long double test = 0;
    rep(i, n) {
        start += a[i].second;
        test += a[i].second * a[i].first;
    }

    if (test / start < t) {
        cout << "0\n";
        return 0;
    }

    long double low = 0;
    long double high = start;
    rep(i, 300) {
        long double mid = (high + low) / 2.0L;

        long double ans = 0;

        long double tmp = mid;
        long double total = 0;

        rep(i, n) {
            if (a[i].second >= tmp) {
                ans += tmp * a[i].first;
                total += tmp;
                break;
            }

            ans += a[i].second * a[i].first;
            total += a[i].second;
            tmp -= a[i].second;
        }

        ans /= total;

        // cout << high - low << ' ' << mid << ' ' << ans << '\n';

        if (ans <= t) {
            low = mid;
            continue;
        }

        high = mid;
    }

    long double tmp = low;
    long double total = 0;
    long double temp = 0;

    rep(i, n) {
        if (a[i].second >= tmp) {
            temp += tmp * a[i].first;
            total += tmp;
            break;
        }
        
        temp += a[i].second * a[i].first;
        total += a[i].second;
        tmp -= a[i].second;
    }

    temp /= total;

    // long double eps = 1e-9;
    // if (abs(t - temp) >= eps) {
    //     cout << "0\n";
    //     return 0;
    // }

    cout << setprecision(9) << low << '\n';
}
